NXTSensor subclass: #NXTColorLightSensor
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Enchanting-NXT Peripherals'!

!NXTColorLightSensor methodsFor: 'as yet unclassified' stamp: 'JM 8/23/2011 10:31'!
emitInitializationCodeOn: aStream for: anExporter
"Outputs the code to initialize NXT peripherals."

"Output should look something like:
	public static final ColorLightSensor COLOR_LIGHT_SENSOR = new ColorLightSensor(SensorPort.S2,ColorLightSensor.TYPE_COLORRED);"

	| sensorClassName  |

	sensorClassName _ anExporter codeSpecFrom: concreteType asString.

	anExporter indentOn: aStream.
	aStream nextPutAll: 'public static final ', 
		sensorClassName, ' ', self variableName, ' = new ',
		sensorClassName, '(', self portName , ');'; cr.
! !

"-- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- "!

NXTColorLightSensor class
	instanceVariableNames: ''!

!NXTColorLightSensor class methodsFor: 'accessing' stamp: 'JM 8/23/2011 10:37'!
baseName

	^ 'color light sensor'! !

!NXTColorLightSensor class methodsFor: 'accessing' stamp: 'JM 8/23/2011 10:32'!
concreteTypes
"Returns a list of physical devices that implement the functions of this class."


	^ #(
		'NXT Color Sensor'
	).! !


!NXTColorLightSensor class methodsFor: 'block specs' stamp: 'JM 8/23/2011 10:33'!
configBlockSpec

	^ 'Measures color and light using a %p named %s.'.! !

!NXTColorLightSensor class methodsFor: 'block specs' stamp: 'JM 8/23/2011 10:33'!
providesBlocks
"Returns a list of block specifications to be used in the main user interface if there is any device configured that can use these blocks.  Note that the 'selectors' are all unique, start with the class name followed by a colon, but do not actually have functions that go with them."

	| blocks |
	
	blocks _ #(
		'sensing'
			('%P sees light?' 				b	NXTColorLightSensor:seesLight:)
			('%P %J' 						r	NXTColorLightSensor:sensor:param:)
			('turn %P''s lamp %Q'			-	NXTColorLightSensor:setLightColor:)
			('%P set %K to %n' 				-	NXTColorLightSensor:sensor:param:set:)
			'-'
			('start auto-calibrating %P'		-	NXTColorLightSensor:startAutoCalibration:)
			('auto-calibrate %P to include current reading'	-	NXTColorLightSensor:addReadingToCalibration)
		).

	^ blocks  ! !


!NXTColorLightSensor class methodsFor: 'dropdown lists' stamp: 'JM 8/23/2011 10:31'!
customListNumber: aNumber
"Peripherals can return custom lists (or nil)."

	(aNumber = 1) ifTrue: [
		"Things that can be read from the sensor or its settings"
		^ #('brightness' 'raw value' 'darkest point' 'brightest point' 'red value' 'green value' 'blue value' 'color id')	
	].
	(aNumber = 2) ifTrue: [
		"Things you can set on the sensor"
		^ #('darkest point' 'brightest point')	
	].
	(aNumber = 3) ifTrue: [
		"Turn the lamp off or on (possibly with a color)"
		^ #('on (red)' 'on (green)' 'on (blue)' 'off (ambient)')	
	].

	^ nil.! !
